<?php
/**
 * Created by PhpStorm.
 * User: jderosa
 * Date: 29/04/20
 * Time: 11.15
 */

namespace FiloBlu\Rma\Block\Email;
use FiloBlu\Rma\Api\EasyReturnRepositoryInterface;
use Magento\Directory\Model\RegionFactory;

class PickupAddress extends \Magento\Rma\Block\Email\Items
{
    /**
     * @var EasyReturnRepositoryInterface
     */
    private $easyReturnRepository;
    /**
     * @var RegionFactory
     */
    private $regionFactory;


    /**
     * PickupAddress constructor.
     * @param \Magento\Framework\View\Element\Template\Context $context
     * @param \Magento\Framework\Data\Collection\ModelFactory $modelFactory
     * @param \Magento\Eav\Model\Form\Factory $formFactory
     * @param \Magento\Eav\Model\Config $eavConfig
     * @param \Magento\Rma\Helper\Eav $rmaEav
     * @param EasyReturnRepositoryInterface $easyReturnRepository
     * @param RegionFactory $regionFactory
     * @param array $data
     */
        public function __construct(
            \Magento\Framework\View\Element\Template\Context $context,
            \Magento\Framework\Data\Collection\ModelFactory $modelFactory,
            \Magento\Eav\Model\Form\Factory $formFactory,
            \Magento\Eav\Model\Config $eavConfig,
            \Magento\Rma\Helper\Eav $rmaEav,
            EasyReturnRepositoryInterface $easyReturnRepository,
            RegionFactory $regionFactory,
            array $data = [])
        {
            parent::__construct($context, $modelFactory, $formFactory, $eavConfig, $rmaEav, $data);
            $this->easyReturnRepository = $easyReturnRepository;
            $this->regionFactory = $regionFactory;
        }


    /**
     * @param $rmaId
     * @return bool
     */
      public function isEasyReturn($rmaId){
          try
          {
              if($rmaId){
                  return $this->easyReturnRepository->getByRmaId($rmaId)->getId() ? true : false;
              }else{
                  return false;
              }
          }catch (\Exception $e){
              $this->_logger->critical($e->getMessage());
              return false;
          }catch (\Throwable $t){
              $this->_logger->critical($t->getMessage());
              return false;
          }
      }

    /**
     * @param $rmaId
     * @return \Magento\Sales\Api\Data\OrderAddressInterface|string
     */
      public function getPickupAddress($rmaId){
          try
          {
              $pickupAddress = $this->easyReturnRepository->getByRmaId($rmaId);
              if($regionId = $pickupAddress->getRegionId()){
                  $regionName = $this->regionFactory->create()->load($pickupAddress->getRegionId());
                  $pickupAddress->setRegion($regionName->getName());
              }
              return $pickupAddress->getPickUpAddress();
          }catch (\Exception $e)
          {
              $this->_logger->critical($e->getMessage());
              return "";
          }catch (\Throwable $t){
              $this->_logger->critical($t->getMessage());
              return "";
          }

      }
}